2 # Desc: Template to report seconds until beginning of next day
4 #==BEGIN Define script parameters==
5 #===BEGIN Declare local script functions===
6 yell
() { echo "$0: $*" >&2; } # Yell, Die, Try Three-Fingered Claw technique; # Ref/Attrib: https://stackoverflow.com/a/25515370
7 die
() { yell
"$*"; exit 111; }
8 try
() { "$@" || die
"cannot $*"; }
10 # Desc: Report seconds until next day.
12 # Output: stdout: integer seconds until next day
13 # Output: exit code 0 if stdout > 0; 1 if stdout = 0; 2 if stdout < 0
14 # Usage: timeUntilNextDay
15 # Usage: if ! myTTL="$(timeUntilNextDay)"; then yell "ERROR in if statement"; exit 1; fi
16 # Depends: date 8, echo 8, yell, try
18 local returnState timeCurrent timeNextDay secondsUntilNextDay
19 timeCurrent
="$(date --iso-8601=seconds)" ; # Produce `date`-parsable current timestamp with resolution of 1 second.
20 timeNextDay
="$(date -d "$timeCurrent next day
" --iso-8601=date)"; # Produce timestamp of beginning of tomorrow with resolution of 1 second.
21 secondsUntilNextDay
="$(( $(date +%s -d "$timeNextDay") - $(date +%s -d "$timeCurrent") ))" ; # Calculate seconds until closest future midnight (res. 1 second).
22 if [[ "$secondsUntilNextDay" -gt 0 ]]; then
24 elif [[ "$secondsUntilNextDay" -eq 0 ]]; then
25 returnState
="warning_zero";
26 yell
"WARNING:Reported time until next day exactly zero.";
27 elif [[ "$secondsUntilNextDay" -lt 0 ]]; then
28 returnState
="warning_negative";
29 yell
"WARNING:Reported time until next day is negative.";
32 try
echo "$secondsUntilNextDay"; # Report
34 # Determine function return code
35 if [[ "$returnState" = "true" ]]; then
37 elif [[ "$returnState" = "warning_zero" ]]; then
39 elif [[ "$returnState" = "warning_negative" ]]; then
42 } # Report seconds until next day
43 #===END Declare local script functions===
44 #==END Define script parameters==
47 #==BEGIN sample code==
48 try
echo "Time until next day (seconds):$(timeUntilNextDay)" # simple report
50 if ! myTTL
="$(timeUntilNextDay)"; then yell
"ERROR in if statement for myTTL:$myTTL"; exit 1; fi # Use of exit code to exit early if time <= 0.
53 # Author: Steven Baltaktei Sandoval